# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from ._enums import *

__all__ = [
    'GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseArgs',
    'GoogleCloudAssuredworkloadsV1WorkloadKMSSettingsArgs',
    'GoogleCloudAssuredworkloadsV1WorkloadPartnerPermissionsArgs',
    'GoogleCloudAssuredworkloadsV1WorkloadResourceSettingsArgs',
]

@pulumi.input_type
class GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseArgs:
    def __init__(__self__, *,
                 ekm_provisioning_error_domain: Optional[pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseEkmProvisioningErrorDomain']] = None,
                 ekm_provisioning_error_mapping: Optional[pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseEkmProvisioningErrorMapping']] = None,
                 ekm_provisioning_state: Optional[pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseEkmProvisioningState']] = None):
        """
        External key management systems(EKM) Provisioning response
        :param pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseEkmProvisioningErrorDomain'] ekm_provisioning_error_domain: Indicates Ekm provisioning error if any.
        :param pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseEkmProvisioningErrorMapping'] ekm_provisioning_error_mapping: Detailed error message if Ekm provisioning fails
        :param pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseEkmProvisioningState'] ekm_provisioning_state: Indicates Ekm enrollment Provisioning of a given workload.
        """
        if ekm_provisioning_error_domain is not None:
            pulumi.set(__self__, "ekm_provisioning_error_domain", ekm_provisioning_error_domain)
        if ekm_provisioning_error_mapping is not None:
            pulumi.set(__self__, "ekm_provisioning_error_mapping", ekm_provisioning_error_mapping)
        if ekm_provisioning_state is not None:
            pulumi.set(__self__, "ekm_provisioning_state", ekm_provisioning_state)

    @property
    @pulumi.getter(name="ekmProvisioningErrorDomain")
    def ekm_provisioning_error_domain(self) -> Optional[pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseEkmProvisioningErrorDomain']]:
        """
        Indicates Ekm provisioning error if any.
        """
        return pulumi.get(self, "ekm_provisioning_error_domain")

    @ekm_provisioning_error_domain.setter
    def ekm_provisioning_error_domain(self, value: Optional[pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseEkmProvisioningErrorDomain']]):
        pulumi.set(self, "ekm_provisioning_error_domain", value)

    @property
    @pulumi.getter(name="ekmProvisioningErrorMapping")
    def ekm_provisioning_error_mapping(self) -> Optional[pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseEkmProvisioningErrorMapping']]:
        """
        Detailed error message if Ekm provisioning fails
        """
        return pulumi.get(self, "ekm_provisioning_error_mapping")

    @ekm_provisioning_error_mapping.setter
    def ekm_provisioning_error_mapping(self, value: Optional[pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseEkmProvisioningErrorMapping']]):
        pulumi.set(self, "ekm_provisioning_error_mapping", value)

    @property
    @pulumi.getter(name="ekmProvisioningState")
    def ekm_provisioning_state(self) -> Optional[pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseEkmProvisioningState']]:
        """
        Indicates Ekm enrollment Provisioning of a given workload.
        """
        return pulumi.get(self, "ekm_provisioning_state")

    @ekm_provisioning_state.setter
    def ekm_provisioning_state(self, value: Optional[pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadEkmProvisioningResponseEkmProvisioningState']]):
        pulumi.set(self, "ekm_provisioning_state", value)


@pulumi.input_type
class GoogleCloudAssuredworkloadsV1WorkloadKMSSettingsArgs:
    def __init__(__self__, *,
                 next_rotation_time: pulumi.Input[str],
                 rotation_period: pulumi.Input[str]):
        """
        Settings specific to the Key Management Service.
        :param pulumi.Input[str] next_rotation_time: Input only. Immutable. The time at which the Key Management Service will automatically create a new version of the crypto key and mark it as the primary.
        :param pulumi.Input[str] rotation_period: Input only. Immutable. [next_rotation_time] will be advanced by this period when the Key Management Service automatically rotates a key. Must be at least 24 hours and at most 876,000 hours.
        """
        pulumi.set(__self__, "next_rotation_time", next_rotation_time)
        pulumi.set(__self__, "rotation_period", rotation_period)

    @property
    @pulumi.getter(name="nextRotationTime")
    def next_rotation_time(self) -> pulumi.Input[str]:
        """
        Input only. Immutable. The time at which the Key Management Service will automatically create a new version of the crypto key and mark it as the primary.
        """
        return pulumi.get(self, "next_rotation_time")

    @next_rotation_time.setter
    def next_rotation_time(self, value: pulumi.Input[str]):
        pulumi.set(self, "next_rotation_time", value)

    @property
    @pulumi.getter(name="rotationPeriod")
    def rotation_period(self) -> pulumi.Input[str]:
        """
        Input only. Immutable. [next_rotation_time] will be advanced by this period when the Key Management Service automatically rotates a key. Must be at least 24 hours and at most 876,000 hours.
        """
        return pulumi.get(self, "rotation_period")

    @rotation_period.setter
    def rotation_period(self, value: pulumi.Input[str]):
        pulumi.set(self, "rotation_period", value)


@pulumi.input_type
class GoogleCloudAssuredworkloadsV1WorkloadPartnerPermissionsArgs:
    def __init__(__self__, *,
                 data_logs_viewer: Optional[pulumi.Input[bool]] = None,
                 remediate_folder_violations: Optional[pulumi.Input[bool]] = None):
        """
        Permissions granted to the AW Partner SA account for the customer workload
        :param pulumi.Input[bool] data_logs_viewer: Allow the partner to view inspectability logs and monitoring violations.
        :param pulumi.Input[bool] remediate_folder_violations: Allow partner to monitor folder and remediate violations
        """
        if data_logs_viewer is not None:
            pulumi.set(__self__, "data_logs_viewer", data_logs_viewer)
        if remediate_folder_violations is not None:
            pulumi.set(__self__, "remediate_folder_violations", remediate_folder_violations)

    @property
    @pulumi.getter(name="dataLogsViewer")
    def data_logs_viewer(self) -> Optional[pulumi.Input[bool]]:
        """
        Allow the partner to view inspectability logs and monitoring violations.
        """
        return pulumi.get(self, "data_logs_viewer")

    @data_logs_viewer.setter
    def data_logs_viewer(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "data_logs_viewer", value)

    @property
    @pulumi.getter(name="remediateFolderViolations")
    def remediate_folder_violations(self) -> Optional[pulumi.Input[bool]]:
        """
        Allow partner to monitor folder and remediate violations
        """
        return pulumi.get(self, "remediate_folder_violations")

    @remediate_folder_violations.setter
    def remediate_folder_violations(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "remediate_folder_violations", value)


@pulumi.input_type
class GoogleCloudAssuredworkloadsV1WorkloadResourceSettingsArgs:
    def __init__(__self__, *,
                 display_name: Optional[pulumi.Input[str]] = None,
                 resource_id: Optional[pulumi.Input[str]] = None,
                 resource_type: Optional[pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadResourceSettingsResourceType']] = None):
        """
        Represent the custom settings for the resources to be created.
        :param pulumi.Input[str] display_name: User-assigned resource display name. If not empty it will be used to create a resource with the specified name.
        :param pulumi.Input[str] resource_id: Resource identifier. For a project this represents project_id. If the project is already taken, the workload creation will fail. For KeyRing, this represents the keyring_id. For a folder, don't set this value as folder_id is assigned by Google.
        :param pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadResourceSettingsResourceType'] resource_type: Indicates the type of resource. This field should be specified to correspond the id to the right project type (CONSUMER_PROJECT or ENCRYPTION_KEYS_PROJECT)
        """
        if display_name is not None:
            pulumi.set(__self__, "display_name", display_name)
        if resource_id is not None:
            pulumi.set(__self__, "resource_id", resource_id)
        if resource_type is not None:
            pulumi.set(__self__, "resource_type", resource_type)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[str]]:
        """
        User-assigned resource display name. If not empty it will be used to create a resource with the specified name.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> Optional[pulumi.Input[str]]:
        """
        Resource identifier. For a project this represents project_id. If the project is already taken, the workload creation will fail. For KeyRing, this represents the keyring_id. For a folder, don't set this value as folder_id is assigned by Google.
        """
        return pulumi.get(self, "resource_id")

    @resource_id.setter
    def resource_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "resource_id", value)

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> Optional[pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadResourceSettingsResourceType']]:
        """
        Indicates the type of resource. This field should be specified to correspond the id to the right project type (CONSUMER_PROJECT or ENCRYPTION_KEYS_PROJECT)
        """
        return pulumi.get(self, "resource_type")

    @resource_type.setter
    def resource_type(self, value: Optional[pulumi.Input['GoogleCloudAssuredworkloadsV1WorkloadResourceSettingsResourceType']]):
        pulumi.set(self, "resource_type", value)


