# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'GoogleCloudAssuredworkloadsV1beta1WorkloadEkmProvisioningResponseEkmProvisioningErrorDomain',
    'GoogleCloudAssuredworkloadsV1beta1WorkloadEkmProvisioningResponseEkmProvisioningErrorMapping',
    'GoogleCloudAssuredworkloadsV1beta1WorkloadEkmProvisioningResponseEkmProvisioningState',
    'GoogleCloudAssuredworkloadsV1beta1WorkloadResourceSettingsResourceType',
    'WorkloadComplianceRegime',
    'WorkloadPartner',
]


class GoogleCloudAssuredworkloadsV1beta1WorkloadEkmProvisioningResponseEkmProvisioningErrorDomain(str, Enum):
    """
    Indicates Ekm provisioning error if any.
    """
    EKM_PROVISIONING_ERROR_DOMAIN_UNSPECIFIED = "EKM_PROVISIONING_ERROR_DOMAIN_UNSPECIFIED"
    """
    No error domain
    """
    UNSPECIFIED_ERROR = "UNSPECIFIED_ERROR"
    """
    Error but domain is unspecified.
    """
    GOOGLE_SERVER_ERROR = "GOOGLE_SERVER_ERROR"
    """
    Internal logic breaks within provisioning code.
    """
    EXTERNAL_USER_ERROR = "EXTERNAL_USER_ERROR"
    """
    Error occurred with the customer not granting permission/creating resource.
    """
    EXTERNAL_PARTNER_ERROR = "EXTERNAL_PARTNER_ERROR"
    """
    Error occurred within the partner’s provisioning cluster.
    """
    TIMEOUT_ERROR = "TIMEOUT_ERROR"
    """
    Resource wasn't provisioned in the required 7 day time period
    """


class GoogleCloudAssuredworkloadsV1beta1WorkloadEkmProvisioningResponseEkmProvisioningErrorMapping(str, Enum):
    """
    Detailed error message if Ekm provisioning fails
    """
    EKM_PROVISIONING_ERROR_MAPPING_UNSPECIFIED = "EKM_PROVISIONING_ERROR_MAPPING_UNSPECIFIED"
    """
    Error is unspecified.
    """
    INVALID_SERVICE_ACCOUNT = "INVALID_SERVICE_ACCOUNT"
    """
    Service account is used is invalid.
    """
    MISSING_METRICS_SCOPE_ADMIN_PERMISSION = "MISSING_METRICS_SCOPE_ADMIN_PERMISSION"
    """
    Iam permission monitoring.MetricsScopeAdmin wasn't applied.
    """
    MISSING_EKM_CONNECTION_ADMIN_PERMISSION = "MISSING_EKM_CONNECTION_ADMIN_PERMISSION"
    """
    Iam permission cloudkms.ekmConnectionsAdmin wasn't applied.
    """


class GoogleCloudAssuredworkloadsV1beta1WorkloadEkmProvisioningResponseEkmProvisioningState(str, Enum):
    """
    Indicates Ekm enrollment Provisioning of a given workload.
    """
    EKM_PROVISIONING_STATE_UNSPECIFIED = "EKM_PROVISIONING_STATE_UNSPECIFIED"
    """
    Default State for Ekm Provisioning
    """
    EKM_PROVISIONING_STATE_PENDING = "EKM_PROVISIONING_STATE_PENDING"
    """
    Pending State for Ekm Provisioning
    """
    EKM_PROVISIONING_STATE_FAILED = "EKM_PROVISIONING_STATE_FAILED"
    """
    Failed State for Ekm Provisioning
    """
    EKM_PROVISIONING_STATE_COMPLETED = "EKM_PROVISIONING_STATE_COMPLETED"
    """
    Completed State for Ekm Provisioning
    """


class GoogleCloudAssuredworkloadsV1beta1WorkloadResourceSettingsResourceType(str, Enum):
    """
    Indicates the type of resource. This field should be specified to correspond the id to the right project type (CONSUMER_PROJECT or ENCRYPTION_KEYS_PROJECT)
    """
    RESOURCE_TYPE_UNSPECIFIED = "RESOURCE_TYPE_UNSPECIFIED"
    """
    Unknown resource type.
    """
    CONSUMER_PROJECT = "CONSUMER_PROJECT"
    """
    Deprecated. Existing workloads will continue to support this, but new CreateWorkloadRequests should not specify this as an input value.
    """
    CONSUMER_FOLDER = "CONSUMER_FOLDER"
    """
    Consumer Folder.
    """
    ENCRYPTION_KEYS_PROJECT = "ENCRYPTION_KEYS_PROJECT"
    """
    Consumer project containing encryption keys.
    """
    KEYRING = "KEYRING"
    """
    Keyring resource that hosts encryption keys.
    """


class WorkloadComplianceRegime(str, Enum):
    """
    Required. Immutable. Compliance Regime associated with this workload.
    """
    COMPLIANCE_REGIME_UNSPECIFIED = "COMPLIANCE_REGIME_UNSPECIFIED"
    """
    Unknown compliance regime.
    """
    IL4 = "IL4"
    """
    Information protection as per DoD IL4 requirements.
    """
    CJIS = "CJIS"
    """
    Criminal Justice Information Services (CJIS) Security policies.
    """
    FEDRAMP_HIGH = "FEDRAMP_HIGH"
    """
    FedRAMP High data protection controls
    """
    FEDRAMP_MODERATE = "FEDRAMP_MODERATE"
    """
    FedRAMP Moderate data protection controls
    """
    US_REGIONAL_ACCESS = "US_REGIONAL_ACCESS"
    """
    Assured Workloads For US Regions data protection controls
    """
    HIPAA = "HIPAA"
    """
    Health Insurance Portability and Accountability Act controls
    """
    HITRUST = "HITRUST"
    """
    Health Information Trust Alliance controls
    """
    EU_REGIONS_AND_SUPPORT = "EU_REGIONS_AND_SUPPORT"
    """
    Assured Workloads For EU Regions and Support controls
    """
    CA_REGIONS_AND_SUPPORT = "CA_REGIONS_AND_SUPPORT"
    """
    Assured Workloads For Canada Regions and Support controls
    """
    ITAR = "ITAR"
    """
    International Traffic in Arms Regulations
    """
    AU_REGIONS_AND_US_SUPPORT = "AU_REGIONS_AND_US_SUPPORT"
    """
    Assured Workloads for Australia Regions and Support controls Available for public preview consumption. Don't create production workloads.
    """
    ASSURED_WORKLOADS_FOR_PARTNERS = "ASSURED_WORKLOADS_FOR_PARTNERS"
    """
    Assured Workloads for Partners;
    """
    ISR_REGIONS = "ISR_REGIONS"
    """
    Assured Workloads for Israel
    """
    ISR_REGIONS_AND_SUPPORT = "ISR_REGIONS_AND_SUPPORT"
    """
    Assured Workloads for Israel Regions
    """
    CA_PROTECTED_B = "CA_PROTECTED_B"
    """
    Assured Workloads for Canada Protected B regime
    """


class WorkloadPartner(str, Enum):
    """
    Optional. Partner regime associated with this workload.
    """
    PARTNER_UNSPECIFIED = "PARTNER_UNSPECIFIED"
    LOCAL_CONTROLS_BY_S3NS = "LOCAL_CONTROLS_BY_S3NS"
    """
    Enum representing S3NS (Thales) partner.
    """
    SOVEREIGN_CONTROLS_BY_T_SYSTEMS = "SOVEREIGN_CONTROLS_BY_T_SYSTEMS"
    """
    Enum representing T_SYSTEM (TSI) partner.
    """
    SOVEREIGN_CONTROLS_BY_SIA_MINSAIT = "SOVEREIGN_CONTROLS_BY_SIA_MINSAIT"
    """
    Enum representing SIA_MINSAIT (Indra) partner.
    """
    SOVEREIGN_CONTROLS_BY_PSN = "SOVEREIGN_CONTROLS_BY_PSN"
    """
    Enum representing PSN (TIM) partner.
    """
