# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'ComputeEnginePreferencesLicenseType',
    'ComputeEnginePreferencesPersistentDiskType',
    'GCSPayloadInfoFormat',
    'ImportDataFileFormat',
    'InlinePayloadInfoFormat',
    'ReportState',
    'ReportType',
    'SourceType',
    'VirtualMachinePreferencesCommitmentPlan',
    'VirtualMachinePreferencesSizingOptimizationStrategy',
]


class ComputeEnginePreferencesLicenseType(str, Enum):
    """
    License type to consider when calculating costs for virtual machine insights and recommendations. If unspecified, costs are calculated based on the default licensing plan.
    """
    LICENSE_TYPE_UNSPECIFIED = "LICENSE_TYPE_UNSPECIFIED"
    """
    Unspecified (default value).
    """
    LICENSE_TYPE_DEFAULT = "LICENSE_TYPE_DEFAULT"
    """
    Default Google Cloud licensing plan. Licensing is charged per usage. This a good value to start with.
    """
    LICENSE_TYPE_BRING_YOUR_OWN_LICENSE = "LICENSE_TYPE_BRING_YOUR_OWN_LICENSE"
    """
    Bring-your-own-license (BYOL) plan. User provides the OS license.
    """


class ComputeEnginePreferencesPersistentDiskType(str, Enum):
    """
    Persistent disk type to use. If unspecified (default), all types are considered, based on available usage data.
    """
    PERSISTENT_DISK_TYPE_UNSPECIFIED = "PERSISTENT_DISK_TYPE_UNSPECIFIED"
    """
    Unspecified (default value). Selecting this value allows the system to use any disk type according to reported usage. This a good value to start with.
    """
    PERSISTENT_DISK_TYPE_STANDARD = "PERSISTENT_DISK_TYPE_STANDARD"
    """
    Standard HDD Persistent Disk.
    """
    PERSISTENT_DISK_TYPE_BALANCED = "PERSISTENT_DISK_TYPE_BALANCED"
    """
    Balanced Persistent Disk.
    """
    PERSISTENT_DISK_TYPE_SSD = "PERSISTENT_DISK_TYPE_SSD"
    """
    SSD Persistent Disk.
    """


class GCSPayloadInfoFormat(str, Enum):
    """
    The import job format.
    """
    IMPORT_JOB_FORMAT_UNSPECIFIED = "IMPORT_JOB_FORMAT_UNSPECIFIED"
    """
    Default value.
    """
    IMPORT_JOB_FORMAT_CMDB = "IMPORT_JOB_FORMAT_CMDB"
    """
    Configuration management DB format.
    """
    IMPORT_JOB_FORMAT_RVTOOLS_XLSX = "IMPORT_JOB_FORMAT_RVTOOLS_XLSX"
    """
    RVTools format (XLSX).
    """
    IMPORT_JOB_FORMAT_RVTOOLS_CSV = "IMPORT_JOB_FORMAT_RVTOOLS_CSV"
    """
    RVTools format (CSV).
    """
    IMPORT_JOB_FORMAT_EXPORTED_AWS_CSV = "IMPORT_JOB_FORMAT_EXPORTED_AWS_CSV"
    """
    CSV format exported from AWS using the AWS collection script.
    """
    IMPORT_JOB_FORMAT_EXPORTED_AZURE_CSV = "IMPORT_JOB_FORMAT_EXPORTED_AZURE_CSV"
    """
    CSV format exported from Azure using the Azure collection script.
    """
    IMPORT_JOB_FORMAT_MANUAL_CSV = "IMPORT_JOB_FORMAT_MANUAL_CSV"
    """
    CSV format created manually. For more information, see Manually create and upload data tables.
    """


class ImportDataFileFormat(str, Enum):
    """
    Required. The payload format.
    """
    IMPORT_JOB_FORMAT_UNSPECIFIED = "IMPORT_JOB_FORMAT_UNSPECIFIED"
    """
    Default value.
    """
    IMPORT_JOB_FORMAT_CMDB = "IMPORT_JOB_FORMAT_CMDB"
    """
    Configuration management DB format.
    """
    IMPORT_JOB_FORMAT_RVTOOLS_XLSX = "IMPORT_JOB_FORMAT_RVTOOLS_XLSX"
    """
    RVTools format (XLSX).
    """
    IMPORT_JOB_FORMAT_RVTOOLS_CSV = "IMPORT_JOB_FORMAT_RVTOOLS_CSV"
    """
    RVTools format (CSV).
    """
    IMPORT_JOB_FORMAT_EXPORTED_AWS_CSV = "IMPORT_JOB_FORMAT_EXPORTED_AWS_CSV"
    """
    CSV format exported from AWS using the AWS collection script.
    """
    IMPORT_JOB_FORMAT_EXPORTED_AZURE_CSV = "IMPORT_JOB_FORMAT_EXPORTED_AZURE_CSV"
    """
    CSV format exported from Azure using the Azure collection script.
    """
    IMPORT_JOB_FORMAT_MANUAL_CSV = "IMPORT_JOB_FORMAT_MANUAL_CSV"
    """
    CSV format created manually. For more information, see Manually create and upload data tables.
    """


class InlinePayloadInfoFormat(str, Enum):
    """
    The import job format.
    """
    IMPORT_JOB_FORMAT_UNSPECIFIED = "IMPORT_JOB_FORMAT_UNSPECIFIED"
    """
    Default value.
    """
    IMPORT_JOB_FORMAT_CMDB = "IMPORT_JOB_FORMAT_CMDB"
    """
    Configuration management DB format.
    """
    IMPORT_JOB_FORMAT_RVTOOLS_XLSX = "IMPORT_JOB_FORMAT_RVTOOLS_XLSX"
    """
    RVTools format (XLSX).
    """
    IMPORT_JOB_FORMAT_RVTOOLS_CSV = "IMPORT_JOB_FORMAT_RVTOOLS_CSV"
    """
    RVTools format (CSV).
    """
    IMPORT_JOB_FORMAT_EXPORTED_AWS_CSV = "IMPORT_JOB_FORMAT_EXPORTED_AWS_CSV"
    """
    CSV format exported from AWS using the AWS collection script.
    """
    IMPORT_JOB_FORMAT_EXPORTED_AZURE_CSV = "IMPORT_JOB_FORMAT_EXPORTED_AZURE_CSV"
    """
    CSV format exported from Azure using the Azure collection script.
    """
    IMPORT_JOB_FORMAT_MANUAL_CSV = "IMPORT_JOB_FORMAT_MANUAL_CSV"
    """
    CSV format created manually. For more information, see Manually create and upload data tables.
    """


class ReportState(str, Enum):
    """
    Report creation state.
    """
    STATE_UNSPECIFIED = "STATE_UNSPECIFIED"
    """
    Default Report creation state.
    """
    PENDING = "PENDING"
    """
    Creating Report.
    """
    SUCCEEDED = "SUCCEEDED"
    """
    Successfully created Report.
    """
    FAILED = "FAILED"
    """
    Failed to create Report.
    """


class ReportType(str, Enum):
    """
    Report type.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Default Report type.
    """
    TOTAL_COST_OF_OWNERSHIP = "TOTAL_COST_OF_OWNERSHIP"
    """
    Total cost of ownership Report type.
    """


class SourceType(str, Enum):
    """
    Data source type.
    """
    SOURCE_TYPE_UNKNOWN = "SOURCE_TYPE_UNKNOWN"
    """
    Unspecified
    """
    SOURCE_TYPE_UPLOAD = "SOURCE_TYPE_UPLOAD"
    """
    Manually uploaded file (e.g. CSV)
    """
    SOURCE_TYPE_GUEST_OS_SCAN = "SOURCE_TYPE_GUEST_OS_SCAN"
    """
    Guest-level info
    """
    SOURCE_TYPE_INVENTORY_SCAN = "SOURCE_TYPE_INVENTORY_SCAN"
    """
    Inventory-level scan
    """
    SOURCE_TYPE_CUSTOM = "SOURCE_TYPE_CUSTOM"
    """
    Third-party owned sources.
    """


class VirtualMachinePreferencesCommitmentPlan(str, Enum):
    """
    Commitment plan to consider when calculating costs for virtual machine insights and recommendations. If you are unsure which value to set, a 3 year commitment plan is often a good value to start with.
    """
    COMMITMENT_PLAN_UNSPECIFIED = "COMMITMENT_PLAN_UNSPECIFIED"
    """
    Unspecified commitment plan.
    """
    COMMITMENT_PLAN_NONE = "COMMITMENT_PLAN_NONE"
    """
    No commitment plan.
    """
    COMMITMENT_PLAN_ONE_YEAR = "COMMITMENT_PLAN_ONE_YEAR"
    """
    1 year commitment.
    """
    COMMITMENT_PLAN_THREE_YEARS = "COMMITMENT_PLAN_THREE_YEARS"
    """
    3 years commitment.
    """


class VirtualMachinePreferencesSizingOptimizationStrategy(str, Enum):
    """
    Sizing optimization strategy specifies the preferred strategy used when extrapolating usage data to calculate insights and recommendations for a virtual machine. If you are unsure which value to set, a moderate sizing optimization strategy is often a good value to start with.
    """
    SIZING_OPTIMIZATION_STRATEGY_UNSPECIFIED = "SIZING_OPTIMIZATION_STRATEGY_UNSPECIFIED"
    """
    Unspecified (default value).
    """
    SIZING_OPTIMIZATION_STRATEGY_SAME_AS_SOURCE = "SIZING_OPTIMIZATION_STRATEGY_SAME_AS_SOURCE"
    """
    No optimization applied. Virtual machine sizing matches as closely as possible the machine shape on the source site, not considering any actual performance data.
    """
    SIZING_OPTIMIZATION_STRATEGY_MODERATE = "SIZING_OPTIMIZATION_STRATEGY_MODERATE"
    """
    Virtual machine sizing will match the reported usage and shape, with some slack. This a good value to start with.
    """
    SIZING_OPTIMIZATION_STRATEGY_AGGRESSIVE = "SIZING_OPTIMIZATION_STRATEGY_AGGRESSIVE"
    """
    Virtual machine sizing will match the reported usage, with little slack. Using this option can help reduce costs.
    """
